<?php

namespace App\Controllers\Admin\Customer;

use App\Entities\Customer\AccountEntity;
use App\Helpers\Customer\AccountHelper;
use App\Services\Customer\AccountService;

use CodeIgniter\HTTP\RequestInterface;
use CodeIgniter\HTTP\ResponseInterface;
use Psr\Log\LoggerInterface;

class AccountController extends CustomerController
{
    public function initController(RequestInterface $request, ResponseInterface $response, LoggerInterface $logger)
    {
        parent::initController($request, $response, $logger);
        $this->content_title = lang("{$this->getService()->getClassName()}.title");
        $this->class_path .= $this->getService()->getClassName();
        $this->uri_path .= strtolower($this->getService()->getClassName('/')) . '/';
        // $this->view_path .= strtolower($this->getService()->getClassName()) . DIRECTORY_SEPARATOR;

    }
    public function getService(): AccountService
    {
        if (!$this->_service) {
            $this->_service = new AccountService();
        }
        return $this->_service;
    }
    //Index,FieldForm관련.
    protected function create_process(array $formDatas): AccountEntity
    {
        // 관리자 UID는 현재 인증된 사용자로 설정
        $formDatas['user_uid'] = $this->getMyAuth()->getUIDByAuthInfo();
        return parent::create_process($formDatas);
    }
    //수정관련
    protected function modify_process(mixed $entity, array $formDatas): AccountEntity
    {
        // 관리자 UID는 현재 인증된 사용자로 설정
        $formDatas['user_uid'] = $this->getMyAuth()->getUIDByAuthInfo();
        return parent::modify_process($entity, $formDatas);
    }
}
